#include <stdio.h>
#include <math.h>
double a8[8],b8[8],pi,cx,cy;
FILE   *fp;
char   head[72][80],d[250],f1[50],f2[50],c1[14],c2[14];

xytoad(x,a)
double *x,*a;
{
  double z;
  z=x[0]*x[3]-x[2]*x[1];
  a[0]= x[3]/z;
  a[1]=-x[1]/z;
  a[2]=-x[2]/z;
  a[3]= x[0]/z;
  a[4]= (x[2]*x[5]-x[4]*x[3])/z;
  a[5]= (x[4]*x[1]-x[0]*x[5])/z;
}

#define bok  48.
rad_xy(ac,dc,ra,de,x,y,type,k)
double ac,dc,ra,de,*x,*y;  int type,k;
{
  double xi,xn, tmp,rar,der;
  rar=ra*cx; der=de*cy;
  tmp=atan(tan(der)/cos(rar-ac));
  xi=cos(tmp)*tan(rar-ac)/cos(tmp-dc);
  xn=tan(tmp-dc);
  if(type==1){     // schmidt TELESCOPE
    tmp=sqrt(xi*xi+xn*xn);
    if(tmp!=0.){
      tmp=atan(tmp)/tmp;
      xi*=tmp; xn*=tmp;
    }
  }
  if(type==2){    //  BOK telescope
    tmp=1.+bok*(xi*xi+xn*xn);
    xi*=tmp; xn*=tmp;
  }
  if(k==0){
    *x=b8[0]*xi+b8[2]*xn+b8[4];
    *y=b8[1]*xi+b8[3]*xn+b8[5];
  }
  if(k==1){ *x=xi; *y=xn;}
}

xy_rad(ac,dc,x,y,ra,de,type,k)
double ac,dc,x,y,*ra,*de;  int type,k;
{
  double xi,xn,tmp,tmp1;
  double x1,y1,r1,d1;
  int i;
  xi=a8[0]*x+a8[2]*y+a8[4];
  xn=a8[1]*x+a8[3]*y+a8[5];
  if(type==1){
    tmp=sqrt(xi*xi+xn*xn);
    if(tmp!=0.){
      tmp=tan(tmp)/tmp;
      xi*=tmp;  xn*=tmp;
    }
  }
  if(type==2){
    tmp=1.+bok*(xi*xi+xn*xn);
    for(i=0;i<4;i++){
      x1=xi/tmp; y1=xn/tmp;
      tmp=tan(dc);  tmp1=1.-y1*tmp;
      r1=atan(x1/cos(dc)/tmp1);
      d1=atan((y1+tmp)*cos(r1)/tmp1);
      r1+=ac;
      tmp=atan(tan(d1)/cos(r1-ac));
      x1=cos(tmp)*tan(r1-ac)/cos(tmp-dc);
      y1=tan(tmp-dc);
      tmp=1.+bok*(x1*x1+y1*y1);
    }
    xi/=tmp; xn/=tmp;
  }
  tmp=tan(dc);  tmp1=1.-xn*tmp;
  *ra=atan(xi/cos(dc)/tmp1);
  *de=atan((xn+tmp)*cos(*ra)/tmp1);
  *ra+=ac;
  tmp=(*de)-dc; if(tmp<0.)tmp=-tmp;
  if(tmp>2.){  *de=-(*de);  *ra+=pi; }
  if(*ra<0.)*ra+=(pi+pi);
  if(k==0){ *ra/=cx; *de/=cy; }
}

toms2(aa,c,k)
double aa;           // input
char c[14];          // output
int k;               // input
{
  int  i,j;
  double a,b,x;
  a=aa;
  if(k==1){ if(a>24.)a-=24.; if(a<0.)a+=24.; }
  c[0]=32; if(a<0.){ a=-a; c[0]='-'; }
  i=a; b=(a-i)*60.;
  j=b; x=(b-j)*60.;
  if(j==60){ j=0; i++; }
  if(k==1)sprintf(&c[1],"%2.2d:%2.2d:%6.3f",i,j,x);
  if(k==0)sprintf(&c[1],"%2.2d:%2.2d:%5.2f",i,j,x);
  if(c[7]==32)c[7]='0';   if(c[8]==32)c[8]='0';
  if(c[7]=='6'){
    c[7]='0'; j++; sprintf(&c[4],"%2.2d",j);
    if(c[4]=='6'){
      c[4]='0'; i++; sprintf(&c[1],"%2.2d",i);
    }
    c[3]=':'; c[6]=':';
  }
}

main(int ac, char **av)
{
  int    i,j,k;
  double x3,x4,rc,dc,alpha,delta;
  pi=4.*atan(1.0); cx=pi/12.; cy=pi/180.;
  if(ac<3){ printf("\n\t***** add RA DEC ****\n");
            printf("\n\tUsage: add_radec file n\n");
            printf("\n\t n: start X,Y column\n");
            printf("\n\t notice: should existed a fitsfile with samename in default directory\n\n");
                             
     exit(0); }
  strcpy(f1,av[1]); sscanf(av[2],"%d",&j); j--;
  for(i=0;i<strlen(f1);i++)if(f1[i]=='.')break; f1[i]=0; 
  sprintf(f2,"%s.fit",f1);
  fp=fopen(f2,"rb"); if(!fp){ printf("\n%s not found!\n",f2); exit(0); }
  fread(head,72,80,fp); fclose(fp);
  k=indexpos(head,"A81     ",72);
  if(k==72){ printf("\t%s not calied !\n",f2); exit(0); }
  for(i=0;i<8;i++)sscanf(&head[k+i][10],"%lf",&a8[i]); xytoad(a8,b8);
  rc=a8[6]; dc=a8[7];
  sprintf(f2,av[1]);
  fp=fopen(f2,"r"); if(!fp){ printf("\n%s not found!\n",f2); exit(0); }
l10:
  fgets(d,250,fp); if(feof(fp))goto l20;
  if(d[0]=='#'){ printf("%s",d); goto l10; }
  sscanf(&d[j],"%lf %lf",&x3,&x4); 
  xy_rad(rc,dc,x3,x4,&alpha,&delta,1,0);
  toms2(alpha,c1,1); toms2(delta,c2,0);
  d[strlen(d)-1]=0;
  printf("%s %s %s\n",d,c1,c2);
  goto l10;
l20:
  fclose(fp); 
}
